/**
 * Copyright © CENRA (2016)
 *
 * remi.clement@espaces-naturels.fr
 * 
 * This software is a multi-platform and portable application based on 
 * the scientifical toolbox to monitor wetlands. With this toolbox it’s 
 * possible to calculate indicators «RhoMéO» to monitor quality, 
 * fonctionalities and urban and agricultural pressures of wetlands. 
 * Indicators are calculated using naturalist data entered and/or imported,
 * and geographic data downloaded from a geographic server.
 * 
 * This software is governed by the CeCILL license under French law and
 * abiding by the rules of distribution of free software.  You can  use, 
 * modify and/ or redistribute the software under the terms of the CeCILL
 * license as circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info". 
 * 
 * As a counterpart to the access to the source code and  rights to copy,
 * modify and redistribute granted by the license, users are provided only
 * with a limited warranty  and the software's author,  the holder of the
 * economic rights,  and the successive licensors  have only  limited
 * liability. 
 * 
 * In this respect, the user's attention is drawn to the risks associated
 * with loading,  using,  modifying and/or developing or reproducing the
 * software by the user in light of its specific status of free software,
 * that may mean  that it is complicated to manipulate,  and  that  also
 * therefore means  that it is reserved for developers  and  experienced
 * professionals having in-depth computer knowledge. Users are therefore
 * encouraged to load and test the software's suitability as regards their
 * requirements in conditions enabling the security of their systems and/or 
 * data to be ensured and,  more generally, to use and operate it in the 
 * same conditions as regards security. 
 * 
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL license and that you accept its terms.
*/
package fr.cenra.rhomeo.api.data;

import java.io.Serializable;
import java.time.LocalDate;
import java.util.Objects;
import java.util.function.Predicate;

/**
 *
 * @author Alexis Manin (Geomatys)
 */
public class TrackingPointFilter implements Predicate<Statement>, Serializable {

    public TrackingPoint point;

    public TrackingPointFilter() {}

    public TrackingPointFilter(final TrackingPoint tp) {
        point = tp;
    }

    @Override
    public boolean test(Statement t) {
        if (t == null)
            return false;
        if (!Objects.equals(point == null? null : point.getName(), t.getTrackingPoint()))
            return false;
        return checkDateRange(t.getDate());
    }

    private boolean checkDateRange(final LocalDate toTest) {
        final LocalDate yearStart = (point == null)? null : point.getYearStart();
        final LocalDate yearEnd = (point == null)? null : point.getYearEnd();
        if (toTest ==  yearStart || toTest == yearEnd)
            return true;
        if (toTest == null)
            return false;
        if (yearStart != null && toTest.isBefore(yearStart))
            return false;

        return !(yearEnd != null && toTest.isAfter(yearEnd));
    }

    @Override
    public int hashCode() {
        int hash = 5;
        hash = 89 * hash + Objects.hashCode(this.point);
        return hash;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        final TrackingPointFilter other = (TrackingPointFilter) obj;
        return Objects.equals(this.point, other.point);
    }
}
